#include "bargraph.h"

/*******************
 *   Variables
 ******************/
extern sfr sbit bar_graph_cs;
extern sfr sbit bar_graph_rst;

void (* write_spi )( uint16_t data_in );
/********************
 *   Prototypes
 *******************/
static void bar_graph_reset( void );
static void bar_graph_chip_select( void );

static void bar_graph_reset( void )
{
    bar_graph_rst = 0;
    asm {nop};
    asm {nop};
    asm {nop};
    bar_graph_rst = 1;
}

static void bar_graph_chip_select( void )
{
    bar_graph_cs = 0;
    asm {nop};
    asm {nop};
    asm {nop};
    bar_graph_cs = 1;
}


/***************
 *  Public
 **************/
void bar_graph_init( uint8_t spi_channel )
{

    switch( spi_channel)
    {
        case 1:
            write_spi = SPI1_Write;
        break;
        case 2:
            write_spi = SPI2_Write;
        break;
        case 3:
            write_spi = SPI3_Write;
        break;
    }
    
    bar_graph_reset();
    
    bar_graph_display( 10 );

}


void bar_graph_display( uint8_t digit )
{
    uint8_t temp1, temp2;
    uint16_t temp;

    temp  = ( 1 << digit ) - 1;
    temp1 = ( temp & 0x00FF );
    temp2 = ( temp & 0xFF00 ) >> 8;

    write_spi( temp2 );
    write_spi( temp1 );
    bar_graph_chip_select();
}