#line 1 "C:/Projects/WebServer/bargraph.c"
#line 1 "c:/projects/webserver/bargraph.h"
#line 1 "c:/c4w/mikroelektronika/mikroc pro for arm/include/stdint.h"





typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;
typedef signed long long int64_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;
typedef unsigned long long uint64_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;
typedef signed long long int_least64_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;
typedef unsigned long long uint_least64_t;



typedef signed long int int_fast8_t;
typedef signed long int int_fast16_t;
typedef signed long int int_fast32_t;
typedef signed long long int_fast64_t;


typedef unsigned long int uint_fast8_t;
typedef unsigned long int uint_fast16_t;
typedef unsigned long int uint_fast32_t;
typedef unsigned long long uint_fast64_t;


typedef signed long int intptr_t;
typedef unsigned long int uintptr_t;


typedef signed long long intmax_t;
typedef unsigned long long uintmax_t;
#line 6 "c:/projects/webserver/bargraph.h"
void bar_graph_init( uint8_t spi_channel );
void bar_graph_display( uint8_t digit );
#line 6 "C:/Projects/WebServer/bargraph.c"
extern sfr sbit bar_graph_cs;
extern sfr sbit bar_graph_rst;

void (* write_spi )( uint16_t data_in );
#line 13 "C:/Projects/WebServer/bargraph.c"
static void bar_graph_reset( void );
static void bar_graph_chip_select( void );

static void bar_graph_reset( void )
{
 bar_graph_rst = 0;
 asm {nop};
 asm {nop};
 asm {nop};
 bar_graph_rst = 1;
}

static void bar_graph_chip_select( void )
{
 bar_graph_cs = 0;
 asm {nop};
 asm {nop};
 asm {nop};
 bar_graph_cs = 1;
}
#line 38 "C:/Projects/WebServer/bargraph.c"
void bar_graph_init( uint8_t spi_channel )
{

 switch( spi_channel)
 {
 case 1:
 write_spi = SPI1_Write;
 break;
 case 2:
 write_spi = SPI2_Write;
 break;
 case 3:
 write_spi = SPI3_Write;
 break;
 }

 bar_graph_reset();

 bar_graph_display( 10 );

}


void bar_graph_display( uint8_t digit )
{
 uint8_t temp1, temp2;
 uint16_t temp;

 temp = ( 1 << digit ) - 1;
 temp1 = ( temp & 0x00FF );
 temp2 = ( temp & 0xFF00 ) >> 8;

 write_spi( temp2 );
 write_spi( temp1 );
 bar_graph_chip_select();
}
